#ifndef start_h
#define start_h
//#include "LPC17xx.h"
//#define board 2 //1: lpc1768 2:lpc1769

volatile uint16_t bool_menu=0;
volatile uint8_t tp_tasteNR=0xff;

volatile uint32_t zlrtc=0,zl_anaus;
uint32_t F_DELAY=9078;//100MHZ
volatile uint32_t Timer, timerDrehzahl;
volatile uint8_t sec_alt,touch_cmd1=0,var_menu1=0,prelltimer=0,mp3_pause=0;
volatile uint32_t zl_sec;
volatile uint32_t touch_x=0,touch_y=0;
volatile uint8_t mp3_neustart=0,mp3_anz_verzeichnisse=0,mp3_anz_dateien=0;
volatile uint8_t prellung=0,touch_cmd2;

volatile uint8_t k29_0dauer_1pulse=1,k29_zl_naehstiche=0;



#define mn_mp3 1
#define mn_sdhc 2
#define mn_usbstick 4
#define mn_programmstart 8


// defines sw-spi
#define cs_1_h		  pinSET(cs_1_port,cs_1_pin)
#define cs_1_l		  pinCLR(cs_1_port,cs_1_pin)
#define mosi_1_h		  pinSET(mosi_1_port,mosi_1_pin)
#define mosi_1_l		  pinCLR(mosi_1_port,mosi_1_pin)
#define  sck_1_h		  pinSET(sck_1_port,sck_1_pin)
#define  sck_1_l		  pinCLR(sck_1_port,sck_1_pin)
#define  miso_1		  pinVAL(miso_1_port,miso_1_pin)

#define sck_1_port 0
#define sck_1_pin  15
#define miso_1_port 0
#define miso_1_pin  17
#define mosi_1_port 0
#define mosi_1_pin  18
#define cs_1_port 0
#define cs_1_pin  16

#define 	led_off		pinCLR(led_port,led_pin)
#define 	led_on 		pinSET(led_port,led_pin)
#define 	led_tog 	pinTOG(led_port,led_pin)

//#define 	led_tog 	LPC_GPIO0->FIOPIN^=(1<<22)
#define 	led1_off		pinCLR(3,25)
#define 	led1_on 		pinSET(3,25)
#define 	led1_tog 		LPC_GPIO3->FIOPIN^=(1<<25)//{if(LPC_GPIO3->FIOPIN && (1<<25))led1_off;else led1_on;}
#define 	led2_off		pinCLR(3,26)
#define 	led2_on 		pinSET(3,26)
#define 	led2_tog 		LPC_GPIO3->FIOPIN^=(1<<26)//{if(LPC_GPIO3->FIOPIN && (1<<26))led2_off;else led2_on;}

void tast_pin_init(char port,char pin){
	pinSEL(port,pin,0);
	pinMODE(port,pin,0);//0_pullup 1_repeater 2_no 3_pulldown
	pinOPD(port,pin,0);//0_normal 1_opendrain
	pinDIRin(port,pin);
}
void out_pin_init(char port,char pin){
	pinSEL(port,pin,0);
	pinMODE(port,pin,2);//0_pullup 1_repeater 2_no 3_pulldown
	pinOPD(port,pin,0);//0_normal 1_opendrain
	pinDIRout(port,pin);
	pinSET(port,pin);
}
#define out1_on pinSET(port_out1,pin_out1);
#define out1_off pinCLR(port_out1,pin_out1);




void init_led(void){
switch (board){
case 2:
	LPC_GPIO0->FIODIR|=(1<<22);
	LPC_GPIO0->FIOSET|=(1<<22);
break;
case 1:
	LPC_GPIO3->FIODIR|=(1<<25);
	LPC_GPIO3->FIOSET|=(1<<25);
	LPC_GPIO3->FIODIR|=(1<<26);
	LPC_GPIO3->FIOSET|=(1<<26);
break;
}
;
}

/*
void init_swspi_1(void){
	pinDIRin(miso_1_port,miso_1_pin);
	pinDIRout(mosi_1_port,mosi_1_pin);
	pinDIRout(sck_1_port,sck_1_pin);
	pinDIRout(cs_1_port,cs_1_pin);
	cs_1_h;
	sck_1_h;
	mosi_1_h;
}*/

uint32_t xF_DELAY=9078;//100MHZ
//xF_CPU = 6536;//72MHZ
void _delay_ms(long ms){
	//genau auf 100sec
	//bei 72Mhz F_CPU=6536
	//bei 100Mhz F_CPU=9078
uint32_t i,j=xF_DELAY*ms;
	for(i=0;i<j;i++);
}
void _delay_us(long us){//genau auf 100sec
uint32_t i,j=xF_DELAY*us/1000;
	for(i=0;i<j;i++);
}
#define wait _delay_ms(1000)

void lcd_rtc(void){
	RTCGetTime();
lcd_time();
}

void lcd_rtc_sec(void){
	RTCGetTime();
	lcd_sec();
}



void auto_sommerzeit(void){
//DOY=89;//Tag einstellen
//++++++++++++++ Korrektur + Umschaltung Sommer/Winterzeit ++++++++++++++++
//	ix=(84+(110-(YEAR%100)-((YEAR%100)-13)/4)%7);//test
//	ix=298+(106-(YEAR%100)-((YEAR%100)-13)/4)%7;//test
//u8 DOYx=MON*30+DAYM-1;if((YEAR%100)%4==0)DOYx++;//doy märz
//if (MON>8)DOYx+=3;//doy Okt
		if(DOY>=(84+(110-(YEAR%100)-((YEAR%100)-13)/4)%7)//letzter So im März
		&& (DOY<(298+(106-(YEAR%100)-((YEAR%100)-13)/4)%7))//letzter So im okt
			){//Sommerzeit
				if ((GPREG1>>31)==0){//EEPROM-Wert für Winterzeit
					HOUR++;
					sbi(GPREG1,31);//EEPROM-Wert für sommerzeit setzen
				}
		}else{//Winterzeit
				if ((GPREG1>>31)==1){//EEPROM-Wert für sommerzeit
					HOUR--;
					cbi(GPREG1,31);//EEPROM-Wert für sommerzeit löschen
				}
		}

	//--------------Korrektur + Umschaltung Sommer/Winterzeit ________________
}


//================================================

//int gi_SystickCount;

// Enable interrupts
//static inline void __enable_irq()	{ asm volatile ("cpsie i"); }

// Initialize the CM3 System Tick timer, given desired rate and the current CPU rate
void vF_SysTickInit(int i_CPUClockHz, int i_SystickHz)
{
//	gi_SystickCount = 0;
	/* Configure SysTick to interrupt at the requested rate. */
	NVIC_ST_RELOAD = (( i_CPUClockHz / i_SystickHz )/10) - 1UL;
	NVIC_ST_CTRL = NVIC_SYSTICK_CLK | NVIC_SYSTICK_INT | NVIC_SYSTICK_ENABLE;
}

// Interrupt handler just increments a count forever.
// Note that CM3 interrupt handlers are regular C functions - no special attributes.
/*void vF_SysTickHander(void)
{
	gi_SystickCount++;

}*/

//=========================================
void SysTick_Handler (void)
{
	static int led_timer;
	Timer++;	/* Increment performance counter */
	prelltimer++;
	led_timer++;
	zl_anaus++;
	timerDrehzahl++;
	if (prelltimer>=50){
		prellung=0;
		led_off;
	}

	if (++led_timer >= 100) {
		led_timer = 0;
//		lcd_rtc();
//		led_tog;		/* Toggle LED state */
	}
//#ifdef 	disk_timerproc
//sd-timer
	disk_timerproc();	/* Disk timer process */
//#endif

if (zl_anaus>20){
	out1_on;
	zl_anaus=0;
	}
if (zl_anaus>pulse_aus)out1_off;

}
//================================================

#define EINT0		0x00000001
#define EINT1		0x00000002
#define EINT2		0x00000004
#define EINT3		0x00000008
#define EINT0_EDGE	0x00000001
#define EINT1_EDGE	0x00000002
#define EINT2_EDGE	0x00000004
#define EINT3_EDGE	0x00000008


void RTC_IRQHandler(void){
			//secval = RTC_GetTime (LPC_RTC, RTC_TIMETYPE_SECOND);
	 ILR |= ILR_RTCCIF;		// clear interrupt flag
//	led2_tog;
	zlrtc++;
		// Clear pending interrupt //
		}
/**/

#define max_menu1 6
v u8 prelltimer,k29pause=1;
void EINT0_IRQHandler (void){
 EXTINT = EINT0;		/* clear interrupt */
if(prellung==0){
prellung=1;
//if(k29_0dauer_1pulse==0){
	if(k29pause==0){
		LCD_Clear(0x001F);
		k29pause=1;
		  PWM_Stop( 1 );
	}else{
		LCD_Clear(0x7800);
			k29pause=0;
			  PWM_Start( 1 );
	}
/*}else{
LCD_Clear(0x7800);
k29_zl_naehstiche=0;

if(k29_0dauer_1pulse==1){
k29_0dauer_1pulse=2;
PWM_Start( 1 );}
else{
	if(k29_0dauer_1pulse==2){
	k29_0dauer_1pulse=1;
	PWM_Stop( 1 );}
	}
}
*/

tastatur_4x4();
prelltimer=0;
}
 //while(==0){
 //prelltimer=1;
/* _delay_ms(200);
 backcolor=Red;
 lgw(var_menu1+1,15," ");//=>
 var_menu1++;
 if(var_menu1>max_menu1)var_menu1=0;
 lgw(var_menu1+1,15,"|");//=>
 backcolor=White;*/
 led_tog;
 //}
return;
//NVIC_SystemReset()
}

void EINT1_IRQHandler (void){
EXTINT = EINT1;		/* clear interrupt */
u8 ix;
//for (ix=0;ix<100;ix++);
led_tog;
//mp3->select subdir
//GPREG0 & 0x000000ff =>counter subdir-mp3
//if ((GPREG0&0x7f)+2>mp3_anz_verzeichnisse){GPREG0&=~0x0000007f;}else{GPREG0++;}
GPREG0&=~0x00ffffff;//zl track+buffer resetten
//if((GPREG0 & 0x0000007f)>MP3_anzahl_unterordner)GPREG0&=~(0x0000007f);
sbi(GPREG0,7);//Neustart
//lgi(17,1,GPREG0 & 0x7f);
mp3_neustart=1;
//WDTInit();
return;
}

void EINT2_IRQHandler (void)
{
   EXTINT = EINT2;		/* clear interrupt */
led_tog;
}

void EINT3_IRQHandler (void)
{
   EXTINT = EINT3;		/* clear interrupt */
led_tog;
}

void interrupt_pins_init(void){

	//gpio input
/*	 IO2IntEnF |= (1 << 10);
	 IO2IntEnF |= (1 << 11);
	 IO2IntEnF |= (1 << 12);
	 //IO2IntEnF |= (1 << 13);
*/
		pinSEL(2,10,1);//set P2.10 as EINT0
		pinSEL(2,11,1);
		pinSEL(2,12,1);
	//	pinSEL(2,13,1);

	//PINSEL4 = 0x00100000;	// set P2.10 as EINT0 and
	 //IO2IntEnF = 0x200;	    // Port2.10 is falling edge. */
	 EXTMODE = EINT0_EDGE|EINT1_EDGE|EINT2_EDGE;		/* INT0 edge trigger */
	 EXTPOLAR = 0;				/* INT0 is falling edge by default */

	//NVIC_EnableIRQ(EINT0_IRQn);
	//NVIC_SetPriority(EINT1_IRQn,1);
	NVIC_EnableIRQ(EINT0_IRQn);
	NVIC_EnableIRQ(EINT1_IRQn);
	NVIC_EnableIRQ(EINT2_IRQn);
	//NVIC_EnableIRQ(EINT3_IRQn);
	//NVIC_EnableIRQ(I2C1_IRQn);

}

//==============================================================



#endif
