
//Kennung cmsis
#ifndef PINSEL
//LPC176x.h-V1.09 fehlt
//#include "LPC176x.h"
#endif
#ifndef LPC_PINCON->PINSEL0
//LPC17xx.h-V1.09 fehlt
#endif

//FEHLENDE LPC176x.h
#define NVIC_SYSTICK_CLK		0x00000004
#define NVIC_SYSTICK_INT		0x00000002
#define NVIC_SYSTICK_ENABLE		0x00000001
#define NVIC_ST_RELOAD (*(volatile uint32_t*)0xE000E014)
#define NVIC_ST_CTRL (*(volatile uint32_t*)0xE000E010)

//=========================================
#define GLUE(a, b)  a##b
#define PORT(x)    GLUE(PORT, x)
#define PIN(x)    GLUE(PIN, x)
#define DDR(x)    GLUE(DDR, x)
#define sbi(var, bit) (var|=1<<bit)//set
#define cbi(var, bit) (var&=~(1<<bit))//clear
#define tbi(var, bit) (var^=1<<bit)//toggle
#define gbi(var, bit) (var>>bit&1)//get

//#define FALSE   (0)
//#define TRUE    (1)

#define cortex_m3 1
#define u8 uint8_t
#define u16 uint16_t
#define u32 uint32_t
#define v volatile

//aus LPC176x.h
#define pinSET(portn,pinn) (*(volatile uint32_t*)(0x2009C018UL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinCLR(portn,pinn) (*(volatile uint32_t*)(0x2009C01CUL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinDIRin(portn,pinn)  (*(volatile uint32_t*)(0x2009C000UL+(portn*0x20UL)))&=~(1UL<<pinn)
#define pinDIRout(portn,pinn) (*(volatile uint32_t*)(0x2009C000UL+(portn*0x20UL)))|=(1UL<<pinn)
#define pinSEL(p,b,v)		PINSEL[(p) * 2 + (b) / 16] = (PINSEL[(p) * 2 + (b) / 16] & ~(3 << ((b) * 2 % 32))) | (v << ((b) * 2 % 32))
#define pinVAL(portn,pinn) ((*(volatile uint32_t*)(0x2009C014UL+(portn*0x20UL))& (1<<pinn))>>pinn)
#define pinTOG(portn,pinn) ((*(volatile uint32_t*)(0x2009C014UL+(portn*0x20UL))^= (1<<pinn)))

#define pinMODE(p,b,v) PINMODE[(p) * 2 + (b) / 16] = (PINMODE[(p) * 2 + (b) / 16] & ~(3 << ((b) * 2 % 32))) | (v << ((b) * 2 % 32))
#define pinOPD(p,b,v) (PINMODE_OD[p] & ~(1 << (b))) | ((v) << (b))
#define mode_pullup   0
#define mode_repeater 1
#define mode_non 		2
#define mode_pulldown 3
#define opd_normal 0
#define opd_opendrain 1

#define ENABLE 1
#define DISABLE 0
